#!/usr/bin/env python
# -*- coding: utf-8 -*-

import pyaudio
import wave
import numpy as np
import datetime
import random
import json
from BrainAction import BrainAction
from news_rp_speak import RandomSpeech
from GetMyappId import GetappId

#設定
CHUNK = 1024*2
FORMAT = pyaudio.paInt16
CHANNELS = 1
RATE = 16000

RECORD_SECONDS = 5#録音時間
threshold = 0.1#キャッチする音量


#処理用のインスタンスの生成
BrainAction=BrainAction()

f = open('keylist.json') # jsonファイルを開く
t = json.load(f)
n = "Id_docomo"
keyflg="OK"
#jsonファイルのキー名を取得
keyname=t.keys()

if n in keyname:
     print(keyflg)
else:
    keyflg = "NO"
    
if keyflg=="NO":
    MyappId=GetappId()
    t.update({"Id_docomo":MyappId['appId']})
    json.dump(t,open('keylist.json','w'),indent=4)

BrainAction.google_url='---------------------------'
BrainAction.google_key=t['k_google'] 
BrainAction.google_spread=t['s_google']#----追加------
BrainAction.docomo_key=t['k_docomo']
BrainAction.dialogF_token=t['t_dialogF']
BrainAction.docomo_Id=t['Id_docomo']
voicefile1='voice.wav'
outputfile='voice.flac' # Google用の音声データ

#音声を拾う
p = pyaudio.PyAudio()

stream = p.open(format = FORMAT,
    channels = CHANNELS,
    rate = RATE,
    input = True,
    frames_per_buffer = CHUNK
)

#カウントスタート(スタート時間を取得)
d = datetime.datetime.now() 

#ランダムに数字を取得(時間用)
numRV = random.randint(5,20)
intM = numRV*60
print(intM)

while True:
    
    if (datetime.datetime.now()-d).seconds >= intM: #○分間カウントする
        RandomSpeech()
        d = datetime.datetime.now() #発声後のカウントスタート(スタート時間を取得)

        #ランダムに数字を取得(時間用)
        numRV = random.randint(5,20)
        intM = numRV*60
        print(intM)
    
    data = stream.read(CHUNK,exception_on_overflow = False)

    x = np.frombuffer(data, dtype="int16") / 32768.0#intの最大値

    #設定した音量より大きい場合に録音データ(ファイル)を作成する
    print (x.max())
    if x.max() > threshold:
        print("Recording")



        all = []
        all.append(data)
        for i in range(0, int(RATE / CHUNK * int(RECORD_SECONDS))):
            data = stream.read(CHUNK,exception_on_overflow = False)
            all.append(data)
        data = b''.join(all)

        out = wave.open(voicefile1,'w')
        out.setnchannels(CHANNELS)
        out.setsampwidth(2)
        out.setframerate(RATE)
        out.writeframes(data)
        out.close()

        print("Saved")

        #フラグにより最初のアクションか、続きのアクション制御
        #各々のアクションはBrainActionというクラスで処理する。
        print(BrainAction.flg_action)
        if BrainAction.flg_action=='ini':
            BrainAction.Action_1st(voicefile1,outputfile)
        else:
            BrainAction.Action_2nd(voicefile1,outputfile)

        d = datetime.datetime.now() #カウントスタート(スタート時間を取得)

        #ランダムに数字を取得(時間用)
        numRV = random.randint(5,20)
        intM = numRV*60
        print(intM)

#終了処理
stream.close()
p.terminate()

